diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
index 5d0405b4f..54e75a7ac 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
@@ -1,16 +1,18 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -22,7 +24,7 @@ public abstract class BlockLogicEdible
     public int maxBites;
 
     public BlockLogicEdible(final @NotNull Block<?> block, final int maxBites, final @NotNull Supplier<@NotNull Item> dropItemSupplier) {
-        super(block, Material.cake);
+        super(block, Materials.CAKE);
         this.maxBites = maxBites;
         this.itemSupplier = dropItemSupplier;
     }
@@ -47,11 +49,11 @@ public abstract class BlockLogicEdible
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
-    private void eatSlice(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player) {
+    private void eatSlice(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player) {
         if (player.getHealth() < player.getMaxHealth()) {
             player.heal(this.getHealAmount(world, tilePos));
             final int data = world.getBlockData(tilePos) + 1;
@@ -64,7 +66,7 @@ public abstract class BlockLogicEdible
         }
     }
 
-    public abstract int getHealAmount(final @NotNull World world, final @NotNull TilePos tilePos);
+    public abstract int getHealAmount(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     public final int getHealAmount(final @NotNull World world, final int x, final int y, final int z) {
@@ -72,7 +74,7 @@ public abstract class BlockLogicEdible
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         if (player.getHealth() == player.getMaxHealth()) {
             return false;
         }
@@ -82,7 +84,7 @@ public abstract class BlockLogicEdible
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
         if (!super.canPlaceAt(world, tilePos)) {
             return false;
         } else {
@@ -91,14 +93,14 @@ public abstract class BlockLogicEdible
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         if (!this.canStay(world, tilePos)) {
             world.setBlockIdNotify(tilePos, 0);
         }
     }
 
     @Override
-    public boolean canStay(final @NotNull World world, final @NotNull TilePos tilePos) {
-        return world.getBlockMaterial(tilePos.down()).isSolid();
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return world.getBlockMaterial(tilePos.add(Direction.DOWN, new TilePos())).isSolid();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index 38967af71..522ed5823 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
@@ -11,16 +12,17 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.IBonemealable;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -31,7 +33,7 @@ public class BlockLogicFarmland
     public static final int MASK_WET = 0b0000_1111;
 
     public BlockLogicFarmland(final @NotNull Block<?> block) {
-        super(block, Material.dirt);
+        super(block, Materials.DIRT);
 
         this.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
         block.withLightBlock(255);
@@ -68,17 +70,17 @@ public class BlockLogicFarmland
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
-        return AABB.fromPool(tilePos.x, tilePos.y, tilePos.z, tilePos.x + 1, tilePos.y + 1, tilePos.z + 1);
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1, tilePos.y() + 1, tilePos.z() + 1);
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
-        final @NotNull Material material = source.getBlockMaterial(tilePos.up());
-        if (material == Material.vegetable) {
-            return AABB.fromPool(0, 0, 0, 1, 1, 1);
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        final @NotNull Material material = source.getBlockMaterial(tilePos.up(new TilePos()));
+        if (material == Materials.VEGETABLE) {
+            return new AABBd(0, 0, 0, 1, 1, 1);
         } else {
-            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
+            return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
         }
     }
 
@@ -98,12 +100,12 @@ public class BlockLogicFarmland
 
     }
 
-    private boolean isCropsNearby(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private boolean isCropsNearby(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int radius = 0;
         final @NotNull TilePos localPos = new TilePos(tilePos);
-        for (localPos.x = tilePos.x - radius; localPos.x <= tilePos.x + radius; localPos.x++) {
-            for (localPos.z = tilePos.z - radius; localPos.z <= tilePos.z + radius; localPos.z++) {
-                if (world.getBlockId(localPos.up()) == Blocks.CROPS_WHEAT.id()) {
+        for (localPos.x = tilePos.x() - radius; localPos.x <= tilePos.x() + radius; localPos.x++) {
+            for (localPos.z = tilePos.z() - radius; localPos.z <= tilePos.z() + radius; localPos.z++) {
+                if (world.getBlockId(localPos.set(localPos.x, tilePos.y() + 1, localPos.z)) == Blocks.CROPS_WHEAT.id()) {
                     return true;
                 }
             }
@@ -119,15 +121,15 @@ public class BlockLogicFarmland
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return side == Side.TOP ? PartialSupport.INSTANCE : FullSupport.INSTANCE;
     }
 
-    private boolean isWaterNearby(final @NotNull World world, final @NotNull TilePos tilePos, final int range) {
+    private boolean isWaterNearby(final @NotNull World world, final @NotNull TilePosc tilePos, final int range) {
         final @NotNull TilePos localPos = new TilePos(tilePos);
-        for (localPos.x = tilePos.x - range; localPos.x <= tilePos.x + range; localPos.x++) {
-            for (localPos.y = tilePos.y - range; localPos.y <= tilePos.y + range; localPos.y++) {
-                for (localPos.z = tilePos.z - range; localPos.z <= tilePos.z + range; localPos.z++) {
+        for (localPos.x = tilePos.x() - range; localPos.x <= tilePos.x() + range; localPos.x++) {
+            for (localPos.y = tilePos.y() - range; localPos.y <= tilePos.y() + range; localPos.y++) {
+                for (localPos.z = tilePos.z() - range; localPos.z <= tilePos.z() + range; localPos.z++) {
                     if (Blocks.hasTag(world.getBlockId(localPos), BlockTags.IS_WATER)) {
                         return true;
                     }
@@ -139,7 +141,7 @@ public class BlockLogicFarmland
     }
 
     @Override
-    public void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity walker) {
+    public void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity walker) {
         if (world.rand.nextInt(4) == 0) {
             if (walker instanceof final @NotNull Player player) {
                 final @Nullable ItemStack bootsSlotStack = player.getItemInArmorSlot(HumanArmorShape.BOOTS);
@@ -156,14 +158,14 @@ public class BlockLogicFarmland
     }
 
     @Override
-    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
         world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
-        final @NotNull Material material = world.getBlockMaterial(tilePos.up());
-        if (material.isSolid() && material != Material.vegetable) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+        final @NotNull Material material = world.getBlockMaterial(tilePos.up(new TilePos()));
+        if (material.isSolid() && material != Materials.VEGETABLE) {
             if (isWet(world.getBlockData(tilePos))) {
                 world.setBlockIdNotify(tilePos, Blocks.MUD.id());
             } else {
@@ -174,7 +176,7 @@ public class BlockLogicFarmland
         }
     }
 
-    private boolean canBecomeWet(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private boolean canBecomeWet(final @NotNull World world, final @NotNull TilePosc tilePos) {
         // If there's water within 1 block, it can become wet
         if (this.isWaterNearby(world, tilePos, 1))
             return true;
@@ -182,9 +184,9 @@ public class BlockLogicFarmland
         // If there's water 3 blocks...
         if (this.isWaterNearby(world, tilePos, 4)) {
             final @NotNull TilePos localPos = new TilePos(tilePos);
-            for (localPos.x = tilePos.x - 1; localPos.x <= tilePos.x + 1; localPos.x++) {
-                for (localPos.y = tilePos.y - 1; localPos.y <= tilePos.y + 1; localPos.y++) {
-                    for (localPos.z = tilePos.z - 1; localPos.z <= tilePos.z + 1; localPos.z++) {
+            for (localPos.x = tilePos.x() - 1; localPos.x <= tilePos.x() + 1; localPos.x++) {
+                for (localPos.y = tilePos.y() - 1; localPos.y <= tilePos.y() + 1; localPos.y++) {
+                    for (localPos.z = tilePos.z() - 1; localPos.z <= tilePos.z() + 1; localPos.z++) {
                         //...And the block is next to another wet mud block, it can become wet
                         final int bID = world.getBlockId(localPos);
                         if (bID == Blocks.MUD.id() || (bID == Blocks.FARMLAND_DIRT.id() && BlockLogicFarmland.isWet(world.getBlockData(localPos)))) {
@@ -205,14 +207,14 @@ public class BlockLogicFarmland
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         if (rand.nextInt(2) != 0) {
             world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay() - rand.nextInt(10) + rand.nextInt(10));
             return;
         }
         final int data = world.getBlockData(tilePos);
         final int hydration = getWet(data);
-        if (this.isWaterNearby(world, tilePos, 4) || world.isBlockBeingRainedOn(tilePos.up())) {
+        if (this.isWaterNearby(world, tilePos, 4) || world.isBlockBeingRainedOn(tilePos.up(new TilePos()))) {
             if (hydration < 15 && this.canBecomeWet(world, tilePos)) {
                 world.setBlockDataNotify(tilePos, setWet(data, hydration + 1));
                 world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay() - rand.nextInt(10) + rand.nextInt(10));
@@ -228,7 +230,7 @@ public class BlockLogicFarmland
     }
 
     @Override
-    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         final int data = world.getBlockData(tilePos);
         if (!isFertilized(data) && itemStack.consumeItem(player)) {
             world.setBlockDataNotify(tilePos, setFertilized(data, true));
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index eb4c4f497..7fba10c2d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -1,26 +1,28 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
-import java.util.Objects;
 
 public class BlockLogicFence
     extends BlockLogic
     implements IPaintable {
     public BlockLogicFence(final @NotNull Block<?> block) {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
     }
 
     @Override
@@ -29,7 +31,7 @@ public class BlockLogicFence
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (side.isVertical()) {
             return PartialSupport.INSTANCE.center();
         } else {
@@ -38,41 +40,41 @@ public class BlockLogicFence
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
-        return Objects.requireNonNull(super.getCollisionAABB(source, tilePos)).expand(0, 0.5, 0);
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return MathHelper.aabbExpand(super.getBoundsFromState(source, tilePos), 0, 0.5, 0, new AABBd());
     }
 
     @Override
-    public void getCollisionAABBs(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull AABB aabb, final @NotNull List<@NotNull AABB> aabbList) {
+    public void getCollisionAABBs(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull AABBdc aabb, final @NotNull List<@NotNull AABBdc> aabbList) {
         final boolean connectEast = this.canConnectTo(world, tilePos, Side.EAST);
         final boolean connectWest = this.canConnectTo(world, tilePos, Side.WEST);
         final boolean connectSouth = this.canConnectTo(world, tilePos, Side.SOUTH);
         final boolean connectNorth = this.canConnectTo(world, tilePos, Side.NORTH);
         final double thickness = 0.5 - 0.375;
         if (connectEast) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 1, 1.5, 0.5 + thickness).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0.5 - thickness, 0, 0.5 - thickness, 1, 1.5, 0.5 + thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
         if (connectWest) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
         if (connectSouth) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 1).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 1).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
         if (connectNorth) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0, 0.5 + thickness, 1.5, 0.5 + thickness).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0.5 - thickness, 0, 0, 0.5 + thickness, 1.5, 0.5 + thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
         if (!connectEast && !connectWest && !connectSouth && !connectNorth) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final boolean connectXPos = this.canConnectTo(source, tilePos, Side.EAST);
         final boolean connectXNeg = this.canConnectTo(source, tilePos, Side.WEST);
         final boolean connectZPos = this.canConnectTo(source, tilePos, Side.SOUTH);
         final boolean connectZNeg = this.canConnectTo(source, tilePos, Side.NORTH);
-        return AABB.fromPool((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
+        return new AABBd((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
     }
 
     @Override
@@ -85,9 +87,10 @@ public class BlockLogicFence
         return false;
     }
 
-    public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side) {
-        final Block<?> b = source.getBlock(tilePos.add(side.getDirection()));
-        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection())) == side.getOpposite());
+    public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        TilePos queryPos = new TilePos();
+        final Block<?> b = source.getBlock(tilePos.add(side.getDirection(), queryPos));
+        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
     }
 
     @Deprecated
@@ -96,7 +99,7 @@ public class BlockLogicFence
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         world.setBlockId(tilePos, Blocks.FENCE_PLANKS_OAK_PAINTED.id());
         Blocks.FENCE_PLANKS_OAK_PAINTED.getLogic().setColor(world, tilePos, color);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
index 089064678..8d43bf7ea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
@@ -6,6 +6,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -15,13 +16,14 @@ public class BlockLogicFenceChainlink extends BlockLogicFenceThin {
     }
 
     @Override
-    public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection()));
-        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection())) == side.getOpposite());
+    public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        TilePos queryPos = new TilePos();
+        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection(), queryPos));
+        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
     }
 
     @Override
-    public boolean isClimbable(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean isClimbable(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return true;
     }
 }
